local entity_id = GetUpdatedEntityID()

local x, y = EntityGetTransform( entity_id )

SetRandomSeed( GameGetFrameNum(), x + y + entity_id )

local random_number = Random(1,2)

if random_number == 1 then

	go_right = true
	
elseif random_number == 2 then

	go_right = false
	
end

local no_movement = false

local did_hit_left = RaytracePlatforms(x - 1, y , x - 1, y)
local did_hit_right = RaytracePlatforms(x + 1, y, x + 1, y)
local did_hit_left_up = RaytracePlatforms(x - 1, y - 1 , x - 1, y -1)
local did_hit_right_up = RaytracePlatforms(x + 1, y - 1 , x + 1, y -1)
local did_hit_bottom = RaytracePlatforms(x, y + 1, x, y + 1)

local did_hit_left2 = RaytracePlatforms(x - 1, y , x - 8, y)
local did_hit_right2 = RaytracePlatforms(x + 1, y, x + 8, y)
local did_hit_left_up2 = RaytracePlatforms(x - 1, y - 1 , x - 8, y -8)
local did_hit_right_up2 = RaytracePlatforms(x + 1, y - 1 , x + 8, y -8)
local did_hit_bottom2 = RaytracePlatforms(x, y + 1, x, y + 8)

local did_hit_left_water = RaytraceSurfacesAndLiquiform(x - 1, y , x - 8, y)
local did_hit_right_water = RaytraceSurfacesAndLiquiform(x + 1, y, x + 8, y)
local did_hit_left_up_water = RaytraceSurfacesAndLiquiform(x - 1, y - 1 , x - 8, y -8)
local did_hit_right_up_water = RaytraceSurfacesAndLiquiform(x + 1, y - 1 , x + 8, y -8)
local did_hit_bottom_water = RaytraceSurfacesAndLiquiform(x, y + 1, x, y + 8)

if ( not (not did_hit_left2 and did_hit_left_water ) ) and
( not (not did_hit_right2 and did_hit_right_water ) ) and
( not (not did_hit_left_up2 and did_hit_left_up_water ) ) and
( not (not did_hit_right_up2 and did_hit_right_up_water ) ) and
( not (not did_hit_bottom2 and did_hit_bottom_water ) ) then

	if not did_hit_bottom then

		GameCreateParticle( "particle_life_ant", x, y + 1, 1, 0, 0, false )
		
	elseif go_right == true then

		if did_hit_right and not did_hit_right_up then
			GameCreateParticle( "particle_life_ant", x + 1 , y - 1, 1, 0, 0, false )
		elseif not did_hit_right then
			GameCreateParticle( "particle_life_ant", x + 1 , y + 1, 1, 0, 0, false )
		else
			no_movement = true
		end
		
	elseif go_right == false then

		if did_hit_left and not did_hit_left_up then
			GameCreateParticle( "particle_life_ant", x - 1 , y - 1, 1, 0, 0, false )
		elseif not did_hit_left then
			GameCreateParticle( "particle_life_ant", x - 1 , y + 1, 1, 0, 0, false )
		else
			no_movement = true
		end
		
	end

	if no_movement == true then
		GameCreateParticle( "particle_life_ant", x, y, 1, 0, 0, false )
	end
end
EntityKill( entity_id )
